/* nefsms.h: this header file was produced automatically by
 * the ./mktbls program, based on input from the file ./modetbl
 */
#ifndef NEFSMS_H
#define NEFSMS_H 1

#if OPT_BACKUP_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_backup_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_backup_choices[]) = {
	{ ".bak",			1 },
	{ "off",			0 },
#if SYS_UNIX
	{ "tilde",			2 },
#endif
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_BACKUP_CHOICES */

#if OPT_BOOL_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_bool_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_bool_choices[]) = {
	{ "FALSE",			FALSE },
	{ "TRUE",			TRUE },
	{ "false",			FALSE },
	{ "off",			FALSE },
	{ "on",				TRUE },
	{ "true",			TRUE },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_BOOL_CHOICES */

#if OPT_BYTEORDER_MARK_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_byteorder_mark_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_byteorder_mark_choices[]) = {
	{ "auto",			ENUM_UNKNOWN },
	{ "none",			bom_NONE },
	{ "utf-16be",			bom_UTF16BE },
	{ "utf-16le",			bom_UTF16LE },
	{ "utf-32be",			bom_UTF32BE },
	{ "utf-32le",			bom_UTF32LE },
	{ "utf-8",			bom_UTF8 },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_BYTEORDER_MARK_CHOICES */

#if OPT_CHARCLASS_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_charclass_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_charclass_choices[]) = {
	{ "arg",			vl_LINESPEC },
	{ "ctl",			vl_CNTRL },
	{ "del",			vl_BSPACE },
	{ "fn",				vl_FENCE },
	{ "id",				vl_IDENT },
	{ "lwr",			vl_LOWER },
	{ "nsp",			vl_NONSPACE },
	{ "num",			vl_DIGIT },
	{ "path",			vl_PATHN },
	{ "prn",			vl_PRINT },
	{ "pun",			vl_PUNCT },
	{ "qid",			vl_QIDENT },
#if OPT_WIDE_CTYPES
	{ "sh",				vl_SHPIPE },
#endif
	{ "sp",				vl_SPACE },
#if OPT_WIDE_CTYPES
	{ "tmp",			vl_SCRTCH },
#endif
	{ "upr",			vl_UPPER },
	{ "wld",			vl_WILD },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_CHARCLASS_CHOICES */

#if OPT_COLOR_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_color_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_color_choices[]) = {
	{ "black",			0 },
	{ "blue",			4 },
#if OPT_16_COLOR
	{ "brightblue",			12 },
	{ "brightcyan",			14 },
	{ "brightgreen",		10 },
	{ "brightmagenta",		13 },
	{ "brightred",			9 },
	{ "brown",			3 },
#endif
	{ "cyan",			6 },
	{ "default",			ENUM_UNKNOWN },
#if DISP_X11
	{ "fcolor",			ENUM_FCOLOR },
#endif
#if OPT_16_COLOR
	{ "gray",			8 },
#endif
	{ "green",			2 },
#if OPT_16_COLOR
	{ "lightgray",			7 },
#endif
	{ "magenta",			5 },
	{ "red",			1 },
#if !OPT_16_COLOR
	{ "white",			7 },
#endif
#if OPT_16_COLOR
	{ "white",			15 },
#endif
#if !OPT_16_COLOR
	{ "yellow",			3 },
#endif
#if OPT_16_COLOR
	{ "yellow",			11 },
#endif
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_COLOR_CHOICES */

#if OPT_CURTOKENS_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_curtokens_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_curtokens_choices[]) = {
	{ "both",			CT_BOTH },
	{ "cclass",			CT_CCLASS },
	{ "regex",			CT_REGEX },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_CURTOKENS_CHOICES */

#if OPT_DIRECTIVE_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_directive_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_directive_choices[]) = {
	{ "break",			D_BREAK },
	{ "else",			D_ELSE },
	{ "elseif",			D_ELSEIF },
	{ "elsewith",			D_ELSEWITH },
	{ "endif",			D_ENDIF },
	{ "endm",			D_ENDM },
	{ "endwhile",			D_ENDWHILE },
	{ "endwith",			D_ENDWITH },
	{ "force",			D_FORCE },
	{ "goto",			D_GOTO },
	{ "hidden",			D_HIDDEN },
	{ "if",				D_IF },
	{ "local",			D_LOCAL },
	{ "quiet",			D_QUIET },
	{ "return",			D_RETURN },
	{ "trace",			D_TRACE },
	{ "while",			D_WHILE },
	{ "with",			D_WITH },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_DIRECTIVE_CHOICES */

#if OPT_FILE_ENCODING_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_file_encoding_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_file_encoding_choices[]) = {
	{ "8bit",			enc_LOCALE },
	{ "ascii",			enc_POSIX },
	{ "auto",			ENUM_UNKNOWN },
	{ "utf-16",			enc_UTF16 },
	{ "utf-32",			enc_UTF32 },
	{ "utf-8",			enc_UTF8 },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_FILE_ENCODING_CHOICES */

#if OPT_FORBUFFERS_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_forbuffers_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_forbuffers_choices[]) = {
	{ "glob",			FB_GLOB },
	{ "mixed",			FB_MIXED },
	{ "regex",			FB_REGEX },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_FORBUFFERS_CHOICES */

#if OPT_HILITE_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_hilite_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_hilite_choices[]) = {
#if OPT_COLOR
	{ "black",			VACOL_0 },
	{ "blue",			VACOL_4 },
#endif
	{ "bold",			VABOLD },
#if OPT_COLOR&&OPT_16_COLOR
	{ "brightblue",			VACOL_C },
	{ "brightcyan",			VACOL_E },
	{ "brightgreen",		VACOL_A },
	{ "brightmagenta",		VACOL_D },
	{ "brightred",			VACOL_9 },
	{ "brown",			VACOL_3 },
#endif
	{ "color",			VACOLOR },
#if OPT_COLOR
	{ "cyan",			VACOL_6 },
#endif
#if OPT_COLOR&&OPT_16_COLOR
	{ "gray",			VACOL_8 },
#endif
#if OPT_COLOR
	{ "green",			VACOL_2 },
#endif
	{ "italic",			VAITAL },
#if OPT_COLOR&&OPT_16_COLOR
	{ "lightgray",			VACOL_7 },
#endif
#if OPT_COLOR
	{ "magenta",			VACOL_5 },
#endif
	{ "none",			0 },
#if OPT_COLOR
	{ "red",			VACOL_1 },
#endif
	{ "reverse",			VAREV },
	{ "underline",			VAUL },
#if OPT_COLOR&&!OPT_16_COLOR
	{ "white",			VACOL_7 },
#endif
#if OPT_COLOR&&OPT_16_COLOR
	{ "white",			VACOL_F },
#endif
#if OPT_COLOR&&!OPT_16_COLOR
	{ "yellow",			VACOL_3 },
#endif
#if OPT_COLOR&&OPT_16_COLOR
	{ "yellow",			VACOL_B },
#endif
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_HILITE_CHOICES */

#if OPT_LOOKUP_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_lookup_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_lookup_choices[]) = {
	{ "bin",			FL_EXECDIR },
	{ "current",			FL_CDIR },
	{ "execable",			FL_EXECABLE },
	{ "home",			FL_HOME },
	{ "libdir",			FL_LIBDIR },
	{ "path",			FL_PATH },
	{ "readable",			FL_READABLE },
	{ "startup",			FL_STARTPATH },
	{ "writable",			FL_WRITEABLE },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_LOOKUP_CHOICES */

#if OPT_MMQUALIFIERS_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_mmqualifiers_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_mmqualifiers_choices[]) = {
	{ "all",			MMQ_ALL },
	{ "any",			MMQ_ANY },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_MMQUALIFIERS_CHOICES */

#if OPT_PARAMTYPES_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_paramtypes_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_paramtypes_choices[]) = {
	{ "bool",			PT_BOOL },
	{ "buffer",			PT_BUFFER },
	{ "directory",			PT_DIR },
	{ "enum",			PT_ENUM },
	{ "file",			PT_FILE },
	{ "integer",			PT_INT },
#if OPT_MAJORMODE
	{ "majormode",			PT_MAJORMODE },
#endif
	{ "mode",			PT_MODE },
	{ "string",			PT_STR },
	{ "variable",			PT_VAR },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_PARAMTYPES_CHOICES */

#if OPT_PATH_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_path_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_path_choices[]) = {
	{ "end",			PATH_END },
	{ "full",			PATH_FULL },
	{ "head",			PATH_HEAD },
	{ "root",			PATH_ROOT },
	{ "short",			PATH_SHORT },
	{ "tail",			PATH_TAIL },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_PATH_CHOICES */

#if OPT_POPUP_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_popup_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_popup_choices[]) = {
	{ "delayed",			POPUP_CHOICES_DELAYED },
	{ "immediate",			POPUP_CHOICES_IMMED },
	{ "off",			POPUP_CHOICES_OFF },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_POPUP_CHOICES */

#if OPT_READERPOLICY_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_readerpolicy_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_readerpolicy_choices[]) = {
	{ "both",			RP_BOTH },
	{ "quick",			RP_QUICK },
	{ "slow",			RP_SLOW },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_READERPOLICY_CHOICES */

#if OPT_RECORDFORMAT_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_recordformat_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_recordformat_choices[]) = {
	{ "fix",			FAB$C_FIX },
	{ "stm",			FAB$C_STM },
	{ "stmcr",			FAB$C_STMCR },
	{ "stmlf",			FAB$C_STMLF },
	{ "udf",			FAB$C_UDF },
	{ "var",			FAB$C_VAR },
	{ "vfc",			FAB$C_VFC },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_RECORDFORMAT_CHOICES */

#if OPT_RECORDATTRS_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_recordattrs_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_recordattrs_choices[]) = {
	{ "blk",			RECORD_ATTRS(0,0,0,1) },
	{ "cr",				RECORD_ATTRS(0,1,0,0) },
	{ "cr,blk",			RECORD_ATTRS(0,1,0,1) },
	{ "cr,prn",			RECORD_ATTRS(0,1,1,0) },
	{ "cr,prn,blk",			RECORD_ATTRS(0,1,1,1) },
	{ "ftn",			RECORD_ATTRS(1,0,0,0) },
	{ "ftn,blk",			RECORD_ATTRS(1,0,0,1) },
	{ "ftn,cr",			RECORD_ATTRS(1,1,0,0) },
	{ "ftn,cr,blk",			RECORD_ATTRS(1,1,0,1) },
	{ "ftn,cr,prn",			RECORD_ATTRS(1,1,1,0) },
	{ "ftn,cr,prn,blk",		RECORD_ATTRS(1,1,1,1) },
	{ "ftn,prn",			RECORD_ATTRS(1,0,1,0) },
	{ "ftn,prn,blk",		RECORD_ATTRS(1,0,1,1) },
	{ "none",			RECORD_ATTRS(0,0,0,0) },
	{ "prn",			RECORD_ATTRS(0,0,1,0) },
	{ "prn,blk",			RECORD_ATTRS(0,0,1,1) },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_RECORDATTRS_CHOICES */

#if OPT_RECORDSEP_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_recordsep_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_recordsep_choices[]) = {
	{ "cr",				RS_CR },
	{ "crlf",			RS_CRLF },
	{ "default",			RS_AUTO },
	{ "lf",				RS_LF },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_RECORDSEP_CHOICES */

#if OPT_SHOWFORMAT_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_showformat_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_showformat_choices[]) = {
	{ "always",			SF_ALWAYS },
	{ "differs",			SF_DIFFERS },
	{ "foreign",			SF_FOREIGN },
	{ "local",			SF_LOCAL },
	{ "never",			SF_NEVER },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_SHOWFORMAT_CHOICES */

#if OPT_VIDEOATTRS_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_videoattrs_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_videoattrs_choices[]) = {
	{ "bold",			VABOLD },
	{ "italic",			VAITAL },
	{ "none",			0 },
	{ "reverse",			VAREV },
	{ "underline",			VAUL },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_VIDEOATTRS_CHOICES */

#if OPT_VTFLASHSEQ_CHOICES
#ifndef realdef
extern const FSM_CHOICES fsm_vtflashseq_choices[];
#else
DECL_EXTERN_CONST(FSM_CHOICES fsm_vtflashseq_choices[]) = {
	{ "normal",			VTFLASH_NORMAL },
	{ "off",			VTFLASH_OFF },
	{ "reverse",			VTFLASH_REVERSE },
	END_CHOICES	/* ends table for name-completion */
};
#endif
#endif /* OPT_VTFLASHSEQ_CHOICES */

#endif /* NEFSMS_H */
